﻿Public Class Form1

    ' Declare the Sleep function from Kernel32.dll
    Private Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Integer)

    ' Arrays to hold checkbox controls for AI channels (not fully utilized in this code for AI functionality)
    Dim checkboxAi(0 To 23) As CheckBox
    ' Arrays to hold textbox controls for AI channel values (not fully utilized in this code for AI functionality)
    Dim textboxAiValue(0 To 23) As TextBox
    ' Arrays to hold checkbox controls for DI channels (not used in this code)
    Dim checkboxDi(0 To 3) As CheckBox
    ' Arrays to hold checkbox controls for DO channels (not used in this code)
    Dim checkboxDo(0 To 3) As CheckBox

    ' Index of the selected device
    Dim DevIndex As Integer
    ' Flag to indicate if the device is running (not fully utilized in this code as the device is closed after starting)
    Dim bRun As Boolean


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim temp As Integer
        Dim i As Integer

        ' Find the USB 3 DAQ device and get the number of available devices
        temp = FindUSB3DAQ()
        If (temp > 0) Then
            ' Add each available device index to the combo box
            For i = 0 To temp - 1
                comboboxDeviceIndex.Items.Add(i)
            Next
            ' Select the first device index in the combo box
            comboboxDeviceIndex.SelectedIndex = 0
            ' Enable the start button
            btnStart.Enabled = True
        Else
            ' Disable the start button if no device is found
            btnStart.Enabled = False
        End If

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click

        Dim i As Integer
        Dim j As Integer
        Dim temp As Integer
        Dim SN(8) As Byte
        Dim WaveData(100) As Single

        ' Get the selected device index from the combo box
        DevIndex = comboboxDeviceIndex.SelectedIndex

        ' Open the device with the selected index
        temp = USB3OpenDevice(DevIndex)

        ' Get and display the device serial number
        temp = USB3GetDeviceSN(DevIndex, SN(0))
        textboxSN.Text = "SN: " + System.Text.Encoding.ASCII.GetString(SN)

        '-----------------------------------------
        ' Ao Wave related settings

        ' Clear the global software trigger flag
        temp = SetUSB3ClrGlobalSoftTrig(DevIndex)

        ' Clear the trigger flag of each of the 4 Ao channels
        For i = 0 To 3
            temp = SetUSB3ClrAoTrigger(DevIndex, i)
        Next


        ' Clear the hardware FIFO space of each of the 4 Ao channels
        For i = 0 To 3
            temp = SetUSB3ClrAoFifo(DevIndex, i)
        Next

        ' Set the output mode of each of the 4 Ao channels to waveform output with hardware FIFO buffering
        For i = 0 To 3
            temp = SetUSB3AoSampleMode(DevIndex, i, 1)
        Next

        ' Set the sampling period of each of the 4 Ao channels input to 10000 ns (10us), with a sampling rate of 100kHz
        For i = 0 To 3
            temp = SetUSB3AoSampleRate(DevIndex, i, 1000)
        Next

        ' Set the trigger source of each of the 4 Ao channels to global software trigger
        For i = 0 To 3
            temp = SetUSB3AoTrigSource(DevIndex, i, 255)
        Next

        ' Set the sampling clock of each of the 4 Ao channels to the internal Ao sampling clock
        For i = 0 To 3
            temp = SetUSB3AoConvSource(DevIndex, i, 0)
        Next

        ' Set the number of waveform Cycles of each of the 4 Ao channels output to 0, which means infinite loop output
        ' If the Cycle number is set to 1, the waveform table data will stop after being output completely once
        For i = 0 To 3
            temp = SetUSB3AoCycle(DevIndex, i, 0)
        Next

        ' Generate a waveform consisting of 100 random numbers between 0 and 1V and store it in WaveData
        For i = 0 To 99
            WaveData(i) = Rnd()
        Next

        ' Download the 100-point waveform WaveData to each of the 4 hardware Ao FIFOs
        For i = 0 To 3
            temp = SetUSB3AoDataFifo(DevIndex, i, WaveData(0), 100)
        Next

        ' Enable the channels that need synchronous sampling output
        '&HF represents each bit corresponding to a channel, and &HF means all 4 channels are enabled for synchronous sampling output
        temp = SetUSB3AoSync(DevIndex, &HF)

        ' Trigger globally with software
        temp = SetUSB3GlobalSoftTrig(DevIndex)

        ' Close the device
        temp = USB3CloseDevice(DevIndex)

    End Sub

End Class